<?php

namespace App\Models\Casts;

use Illuminate\Contracts\Database\Eloquent\CastsAttributes;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Collection;

class CollectionOrNull implements CastsAttributes
{
	/**
	 * Cast the given value.
	 *
	 * @param Model $model
	 * @param string $key
	 * @param mixed $value
	 * @param array $attributes
	 * @return Collection
	 */
	public function get(Model $model,string $key,$value,array $attributes): Collection
	{
		return collect(json_decode($value, true));
	}

	/**
	 * Prepare the given value for storage.
	 *
	 * @param Model $model
	 * @param string $key
	 * @param mixed $value
	 * @param array $attributes
	 * @return string|null
	 */
	public function set(Model $model,string $key,$value,array $attributes): ?string
	{
		return ($value->count()) ? json_encode($value) : NULL;
	}
}